# Twenty First International Obfuscated C Code Contest


## Standard IOCCC stuff

View the `index.html` web page for the given winning entry for information on how
on how to compile it and how to run the winning program.
Look at the winning source and try to figure how it does what it does!
You may then wish to look at the Author's remarks for even more details.

The IOCCC has a web site and now has a number of international mirrors.
The primary site can be found at [www.ioccc.org](https://www.ioccc.org).

Use `make` to compile entries.  It is possible that on non-Unix / non-Linux
systems the Makefile needs to be changed.  See the Makefile for details.

Read over the Makefile for compile/build issues.  Your system may require
certain changes (add or remove a library, add or remove a `#define`).

Some ANSI C compilers are not quite as good as they should be.  If
yours is lacking, you may need to compile using gcc instead of your
local compiler.


## Remarks on some of the entries

We believe you will be impressed with this year's winning entries.  We had
a very difficult time picking a single best from among the other entries
because the overall quality of the submissions were so high.

This year we selected the top 4 entries for particularly high honors:

*   Gold award - Balanced use of obfuscation

    A very extremely subtle and twisted piece of source code!
    Even if you start with the zeitak.alt.c source,
    you will still have a very challenging time to understand it!

*   Silver award - Most elementary use of C

    A fun program that could also have won "Best abuse of
    Ghostscript" because it managed to create some PDF files
    that Ghostscript could not read.

*   Bronze award - Best use of cocoa

    A picture within a picture is worth more than a
    thousand (4 byte) words. :-)

*   Honorable mention - Most complex ASCII fluid

    When you see this program in action, you too will
    very likely say [wow](http://bit.ly/R6ALpK) as we did!

But don't ignore the other winning entries!  There are games, utilities,
eye candy, calculators and graphical tools to explore.

This year, Yusuke Endoh won with two entries, one of which
([endoh1](endoh1/index.html)) won the special Honorable mention award.  Eight of
the winning entries were from people who won in previous years.

This year we had a number of authors from Asia.  We saw our second
authors from China and first from Korea.  We are pleased to see
outstanding entries from areas of the world that have not been
active in past contests.  Will we see an upswing of entries
from South America, Africa and Antarctica next year? :-)

Please note that judging is done completely anonymously.  Please
do NOT reveal your identity in your source code.  In the future we
may disqualify entries that reveal the identity of the submitter!

There were some outstanding entries that did not win.  Unfortunately
some very good entries lost because they:

+ would take years to execute

+ were way way oversize and didn't even attempt to justify their
  excess by a clever abuse of the rules

+ obfuscate themselves by simply invoking a complex
  state machine

+ depend on a single obfuscation trick

+ could only be run on a particular vendor's platform

+ were very similar to previous winning entries

+ were based on an overused theme such as yet another
  fractal display program

+ didn't work as documented

We hope the authors of some of those entries will fix and re-submit
them for the next IOCCC.

There is a risk in submitting an entry that is similar to a well
used theme by previous winning entries.  Previous entries set a very high
bar.  A new winning entry must not only compete against other submissions
form the current year, they must also excel over similar winning entry
in some particularly impressive way.


## Final Comments

**IMPORTANT NOTE**: See [contact.html](../contact.html) for up to date contact details
as well as details on how to provide fixes to any of the entries.
See also [the IOCCC FAQ](../faq.html) for addition information on the IOCCC.


<!--

    Copyright © 1984-2024 by Landon Curt Noll. All Rights Reserved.

    You are free to share and adapt this file under the terms of this license:

	Creative Commons Attribution-ShareAlike 4.0 International (CC BY-SA 4.0)

    For more information, see:

	https://creativecommons.org/licenses/by-sa/4.0/

-->
